<div class="card">
    <h2>Documentation</h2>
    <h4>Getting Started</h4>
    <p>DU-Q is an application template for Angular and is distributed as a CLI project. Current versions is Angular v16 with PrimeNG v16. In case CLI is not installed already, use the command below to set it up.</p>

<pre class="app-code"><code>npm install -g @angular/cli</code></pre>

    <p>Once CLI is ready in your system, extract the contents of the zip file distribution to a folder e.g. verona, cd to the directory,
        install the libraries from npm and then execute "ng serve" to run the application in your local environment.</p>

<pre class="app-code"><code>cd verona
npm install
ng serve</code></pre>

    <p>The application should run at <span class="font-semibold">http://localhost:4200/</span>, you may now start with the development of your application.</p>

    <h5>Important CLI Commands</h5>
    <p>Following commands are derived from CLI.</p>
<pre class="app-code"><code>Run 'ng serve' for a dev server. Navigate to `http://localhost:4200/`. The app will automatically reload if you change any of the source files.

Run 'ng generate component component-name' to generate a new component. You can also use `ng generate directive/pipe/service/class/module`.

Run 'ng build' to build the project. The build artifacts will be stored in the `dist/` directory. Use the `-prod` flag for a production build.

Run 'ng test' to execute the unit tests via [Karma](https://karma-runner.github.io).

Run 'ng e2e' to execute the end-to-end tests via [Protractor](http://www.protractortest.org/).

Run 'ng help' for more options.</code></pre>

    <h5>Angular Compiler Options</h5>
    <p>Verona layout logic is implemented with best Angular practices with first class support for strict mode.</p>

    <h4>Structure</h4>
    <p>Verona consists of 3 main parts; the application layout, layout assets and PrimeNG component theme assets. Layout is placed inside the <span class="text-primary font-medium">src/app/layout</span> folder,
        and the assets are in the <span class="text-primary font-medium">src/assets/layout</span> folder.
    </p>

    <h5>Default Configuration</h5>
    <p>Initial layout configuration can be defined at the main app component by injecting the <span class="text-primary font-medium">LayoutService</span>, this step is optional and only necessary when customizing the defaults. Note that <span class="text-primary font-medium">theme</span> and
        <span class="text-primary font-medium">scale</span> are not reactive since theme is configured outside of Angular at <strong class="font-semibold">index.html</strong> by default and
        initial scale is defined with the <span class="text-primary font-medium">$scale</span> at <strong class="font-semibold">layout.scss</strong>. When default theme or scale is changed at their files initially, it is required to configure the layout service with the matching values
        to avoid sync issues. </p>

<pre class="app-code"><code>import &#123; Component, OnInit &#125; from '@angular/core';
import &#123; PrimeNGConfig &#125; from 'primeng/api';
import &#123; LayoutService &#125; from './layout/service/app.layout.service';

@Component(&#123;
    selector: 'app-root',
    templateUrl: './app.component.html'
&#125;)
export class AppComponent implements OnInit &#123;

    constructor(private primengConfig: PrimeNGConfig, private layoutService: LayoutService) &#123; &#125;

    ngOnInit(): void &#123;
        this.primengConfig.ripple = true;       //enables core ripple functionality

        //optional configuration with the default configuration
        this.layoutService.config = &#123;
            ripple: false,                      //toggles ripple on and off
            inputStyle: 'outlined',             //default style for input elements
            menuMode: 'slim',                   //layout mode of the menu, valid values are "static", "overlay", "slim", and "slim-plus"
            colorScheme: 'light',               //color scheme of the template, valid values are "light", "dim" and "dark"
            theme: 'indigo',                    //default component theme for PrimeNG, see theme section for available values  
            layoutTheme: 'colorScheme',         //theme of the layout, see layout theme section for available values  
            scale: 14                           //size of the body font size to scale the whole application
        &#125;;
    &#125;

&#125;</code></pre>

    <h5>Menu</h5>
    <p>Menu is a separate component defined in <span class="text-primary font-medium">src/app/layout/app.menu.component.ts</span> file and based on PrimeNG MenuModel API. In order to define the menuitems,
        navigate to this file and define your own model as a nested structure.</p>

<pre class="app-code"><code>import &#123; OnInit &#125; from '@angular/core';
import &#123; Component &#125; from '@angular/core';

@Component(&#123;
    selector: 'app-menu',
    templateUrl: './app.menu.component.html'
&#125;)
export class AppMenuComponent implements OnInit &#123;

    model: any[];

    ngOnInit() &#123;
        this.model = [
            &#123;
                label: 'Dashboards',
                icon: 'pi pi-home',
                items: [
                    &#123; label: 'SaaS', icon: 'pi pi-desktop', routerLink: ['/'] &#125;,
                    &#123; label: 'Sales', icon: 'pi pi-chart-bar', routerLink: ['/dashboard-sales'] &#125;
                ]
            &#125;,
            //...
        ];
    &#125;
&#125;</code></pre>

    <h5>Breadcrumb</h5>
    <p>Breadcrumb component is dynamic and retrieves the path information from the router using the <span class="text-primary font-medium">data.breadcrumb</span> property.</p>

<pre class="app-code"><code>&#123; path: 'documentation', data: &#123; breadcrumb: 'Documentation' &#125;, loadChildren: () => import('./demo/components/documentation/documentation.module').then(m => m.DocumentationModule) &#125;</code></pre>

    <h4>Integration with Existing Angular CLI Projects</h4>
    <p>Verona structure is designed in a modular way so that it can easily be integrated with your existing application. We've created a short tutorial with details using the Apollo template however the flow is exactly the same with Verona as well.</p>

    <div class="video-container">
        <iframe width="560" height="315" src="https://www.youtube.com/embed/yl2f8KKY204" frameborder="0" allowfullscreen></iframe>
    </div>

    <h4>PrimeNG Theme</h4>
    <p>Verona provides 20 PrimeNG themes out of the box. Setup of a theme is simple by including the css of theme
        to your bundle that are located inside <span class="text-primary font-medium">assets/layout/styles/theme/</span>
        folder such as <span class="text-primary font-medium">assets/layout/styles/theme/theme-light/blue/theme.css</span>.
    Full list of built-in themes are as follows;</p>

    <ul class="pl-5 line-height-3">
        <li>blue</li>
        <li>cyan</li>
        <li>deeppurple</li>
        <li>green</li>
        <li>indigo</li>
        <li>lime</li>
        <li>orange</li>
        <li>pink</li>
        <li>purple</li>
        <li>yellow</li>
    </ul>

    <p>A custom theme can be developed by the following steps.</p>
    <ul>
        <li>Choose a custom theme name such as "mytheme".</li>
        <li>Create a folder named "mytheme" under <span class="font-semibold">assets/layouts/styles/theme/theme-light/</span> folder.</li>
        <li>Create a file such as theme.scss inside your "mytheme" folder.</li>
        <li>Define the variables listed below in your file and import the dependencies.</li>
        <li>Include the theme.scss to your application.</li>
    </ul>

    <p>Here are the variables required to create a theme.</p>
<pre class="app-code"><code>$primaryColor: #1992D4;
$primaryLightColor: #75bee5 !default;
$primaryDarkColor: #1783bf !default;
$primaryDarkerColor: #1475aa !default;
$primaryTextColor: #ffffff;

$highlightBg: #e8f4fb;
$highlightTextColor: $primaryDarkerColor;

@import '../_variables';
@import '../../theme-base/_components';
@import '../_extensions';</code></pre>

    <h5>Theme Switcher</h5>
    <p>Dynamic theming is built-in to the template and implemented by including the theme via a link tag instead of bundling the theme along with a configurator component to switch it.
        In order to switch your theme dynamically as well, it needs to be compiled to css. An example sass command to compile the css would be;
    </p>

<pre class="app-code"><code>sass --update src/assets/theme/mytheme/theme.scss:src/assets/theme/mytheme/theme.css</code></pre>

    <p class="text-sm">*Note: The sass command above is supported by Dart Sass. Please use Dart Sass instead of Ruby Sass.</p>

    <p>Another alternative would be creating dynamic bundles, please see the <a href="https://www.youtube.com/watch?v=5VOuUdDXRsE" class="font-medium text-primary hover:underline">video tutorial</a> for an example.</p>

    <h5>Theme Designer</h5>
    <p>Verona includes a simplified version of the <a href="https://www.primefaces.org/designer/primeng" class="font-medium text-primary hover:underline">PrimeNG Theme Designer</a> that only includes the main SASS structure. Full list of SASS variables to customize the components further is available at the
        <a href="https://www.primefaces.org/designer/api/primeng/15.0.0/" class="font-medium text-primary hover:underline">SASS API</a> docs.
    </p>

    <h5>Layout Theme</h5>
    <p>Layout theme has two design choices defined using the <i>layoutTheme</i> property of the LayoutService. When set to <b>colorScheme</b> frame of the layout either uses the light or dark colors retrieved from the current color scheme, on the other hand
        if <b>primaryColor</b> is selected the color palette of the PrimeNG component is used. Note that, <i>primaryColor</i> mode is only available to light mode.</p>

    <h4>Figma Design</h4>
    <p>Figma design file of Verona is available at no extra cost at PrimeStore. The download dialog both displays the figma files and source code that are made accessible. 
        The design file is <a href="https://www.figma.com/file/PgQXX4HXMPeCkT74tGajod/Preview-%7C-Verona-2022?node-id=1303%3A750" class="font-medium text-primary hover:underline">accessible</a> in preview mode for trial purposes.</p>
        
    <p>Please note that Verona design file mostly covers the layout and
        does not include the PrimeNG UI components design which is covered by the official <a href="https://www.primefaces.org/primeng/uikit" class="font-medium text-primary hover:underline">UI Kit</a> that requires a separate license and purchase.
    </p>

    <h4>Migration Guide</h4>
    <p>Every important change is included in <b>CHANGELOG.md</b> file at the root folder of the distribution along with the instructions to update. Whenever a major version of Angular is released, a new version of the template
    is provided that mainly brings compatibility support to the PrimeNG component theming. If there are no compatibility issues on component theming e.g. new components or new functionality to PrimeNG,
    you may still update your application to the latest Angular and PrimeNG without the need to waiting for an update.</p>

    <p>Initial integration with an existing CLI application and the update process is similar. During an update, only the layout folder and layout assets folder need to be updated and overriden, see the "Integration with Existing Angular CLI Projects" section for more information.</p>
</div>
